﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI.Widgets;
using Telerik.Web.UI;

public partial class CustomizeFilesInsideFolder_Cs : System.Web.UI.Page
{
	protected static int startIndex = 0;
	protected void Page_Init(object sender, EventArgs e)
	{
		if (!IsPostBack)
			startIndex = 0;
		else
		{
			if (Request.Params["__CALLBACKID"] == RadFileExplorer1.UniqueID)
			{
				System.Web.Script.Serialization.JavaScriptSerializer JSSerializer = new System.Web.Script.Serialization.JavaScriptSerializer();
				Dictionary<string, string> callbackparams = (Dictionary<string, string>)JSSerializer.Deserialize(Request.Params["__CALLBACKPARAM"], typeof(Dictionary<string, string>));
				startIndex = int.Parse(callbackparams["startIndex"]);
			}
		}
	}
	protected void Page_Load(object sender, EventArgs e)
	{
		RadFileExplorer1.Configuration.ContentProviderTypeName = typeof(CustomFileChangeContentProvider).AssemblyQualifiedName;
	}

	public class CustomFileChangeContentProvider : FileSystemContentProvider
	{
		public CustomFileChangeContentProvider(HttpContext context, string[] searchPatterns, string[] viewPaths, string[] uploadPaths, string[] deletePaths, string selectedUrl, string selectedItemTag)
			: base(context, searchPatterns, viewPaths, uploadPaths, deletePaths, selectedUrl, selectedItemTag)
		{
			// Declaring a constructor is required when creating a custom content provider class
		}

		public override DirectoryItem ResolveDirectory(string path)
		{
			//Access the files from the current directory
			DirectoryItem orgDir = base.ResolveDirectory(path);
			//Access the nested directories from the current one
			DirectoryItem orgDir2 = ResolveRootDirectoryAsTree(path);

			//Get a reference to the page
			Page _pageContainsRadFileExplorer = HttpContext.Current.Handler as Page;
			RadFileExplorer fileExplorer = _pageContainsRadFileExplorer.FindControl("RadFileExplorer1") as RadFileExplorer;

			int dirCount = orgDir2.Directories.Length;
			int pageSize = fileExplorer.FileList.PageSize;
			int index = dirCount;

			foreach (FileItem file in orgDir.Files)
			{
				if (index > startIndex + pageSize) break;
				if (startIndex < dirCount && index < dirCount)
					index = dirCount;

				file.Name = index + "_" + file.Name; //A little visible change to the files

				//A custom file-change logic could be implemented here

				index++;
			}
			return orgDir;
		}
	}
}